<?php

class views_optional_argument_numeric extends views_handler_argument_numeric {

  function option_definition() {
    $options = parent::option_definition();

    $options['pass_null'] = array('default' => FALSE, 'bool' => TRUE);

    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

    $form['pass_null'] = array(
      '#type' => 'checkbox',
      '#title' => t('Pass NULL values'),
      '#description' => t('If selected, the filter will pass NULL values even if "Exclude" option is not set.'),
      '#default_value' => !empty($this->options['pass_null']),
      '#fieldset' => 'more',
    );
  }

  function query($group_by = FALSE) {
    $this->ensure_my_table();

    if (!empty($this->options['break_phrase'])) {
      views_break_phrase($this->argument, $this);
    }
    else {
      $this->value = array($this->argument);
    }

    $placeholder = $this->placeholder();
    $null_check = (empty($this->options['not']) && empty($this->options['pass_null'])) ? '' : "OR $this->table_alias.$this->real_field IS NULL";

    if (count($this->value) > 1) {
      $operator = empty($this->options['not']) ? 'IN' : 'NOT IN';
      $this->query->add_where_expression(0, "$this->table_alias.$this->real_field $operator($placeholder) $null_check", array($placeholder => $this->value));
    }
    else {
      $operator = empty($this->options['not']) ? '=' : '!=';
      $this->query->add_where_expression(0, "$this->table_alias.$this->real_field $operator $placeholder $null_check", array($placeholder => $this->argument));
    }
  }

}
